<?php

/* -----------------------start select_to_table-----------------------*/
/* creates a table from query defined outside function. 
   Variables are:
           $query = query to run 
  
   example:
    $x = "SELECT * FROM tlog WHERE TransDate BETWEEN '2004-04-01' AND '2004-04-02' LIMIT 50"
    select_to_table($x);

*/

function select_to_table($query)
{
    $results = mssql_query($query) or
        die("<ul><li>errorno=" . mysql_errno() . "</li>"
            . "<li>error=". mysql_error() . "</li>"
            . "<li>query=" . $query .  . "</li></ul>");
    $number_cols = mssql_num_fields($results);
    //display query
    echo "<b>query: $query</b>";
    //layout table header
    echo "<table border = '1'>\n";
    echo "<tr align='left'>\n";
    for($i=0; $i<$number_cols; $i++) {
        echo "<th>" . mssql_field_name($results,$i). "</th>\n";
    }
    echo "</tr>\n"; //end table header
    //layout table body
    while($row = mssql_fetch_row($results)) {
        echo "<tr align left>\n";
        for ($i=0;$i<$number_cols; $i++) {
            echo "<td>";
            if(!isset($row[$i])) {
                //test for null value
                echo "NULL";
            }
            else {
                echo $row[$i];
            }
            echo "</td>\n";
        }
        echo "</tr>\n";
    }
    echo "</table>\n";
}

/* -------------------------------end select_to_table-------------------*/ 


/* -------------------------------start select_star_from----------------*/
/* creates a table returning all values from a table (SELECT * FROM depts)
   Variables are:
           $table = table to run query on
  
   example:
       select_star_from(depts);
*/

function select_star_from($table)
{
    $query = "SELECT * FROM $table";
    $results = mysql_query($query) or
        die("<ol><li>errorno=" . mysql_errno() . "</li>"
            ."<li>error=" . mysql_error() . "</li>"
            ."<li>query=" . $query . "</li></ol>");
    $number_cols = mysql_num_fields($results);
    //display query
    echo "<b>query: $query</b>";
    //layout table header
    echo "<table border = '1'>\n";
    echo "<tr align='left'>\n";
    for($i=0; $i<$number_cols; $i++) {
        echo "<th>" . mysql_field_name($results,$i). "</th>\n";
    }
    echo "</tr>\n"; //end table header
    //layout table body
    while($row = mysql_fetch_row($results)) {
        echo "<tr align left>\n";
        for ($i=0;$i<$number_cols; $i++) {
            echo "<td>";
            if(!isset($row[$i])) {
                //test for null value
                echo "NULL";
            }
            else {
                echo $row[$i];
            }
            echo "</td>\n";
        }
        echo "</tr>\n";
    }
    echo "</table>\n";
}

/* ------------------------------end select_start_from-----------------0-------*/

/* ------------------------------start select_where_equal----------------------*/
/* creates a table using a SELECT WHERE syntax (SELECT * FROM transmemhead WHERE memNum = '175')
   Variables are
           $table = table for select
        $where = field for where statement
        $whereVar = value for where statement

    example:
        select_where(transmemhead,memNum,175)

*/

function select_where_equal($table,$where,$whereVar)
{
    $query = "SELECT * FROM $table WHERE $where = '$whereVar'";
    $results = mysql_query($query) or
        die("<ol><li>errorno=" . mysql_errno() . "</li>"
            ."<li>error=" . mysql_error() . "</li>"
            ."<li>query=" . $query . "</li></ol>");
    $number_cols = mysql_num_fields($results);
    //display query
    echo "<b>query: $query</b>";
    //layout table header
    echo "<table border = '1'>\n";
    echo "<tr align = 'left'>\n";
    for($i=0; $i<$number_cols; $i++) {
        echo "<th>" . mysql_field_name($results,$i). "</th>\n";
    }
    echo "</tr>\n"; //end table header
    //layout table body
    while($row = mysql_fetch_row($results)) {
        echo "<tr align = 'left'>\n";
        for ($i=0;$i<$number_cols; $i++) {
            echo "<td>";
            if(!isset($row[$i])) {
                //test for null value
                echo "NULL";
            }
            else {
                echo $row[$i];
            }
            echo "</td>\n";
        }
        echo "</tr>\n";
    }
    echo "</table>\n";
}

/* ----------------------------end select_where_equal--------------------------*/

/* ----------------------------start select_where_between----------------------*/
/* creates a table using a SELECT WHERE syntax (SELECT * FROM transmemhead WHERE memNum BETWEEN '175' AND '185')
   Variables are 
           $table = table for select 
        $where = field for where statement
        $whereVar1 = beginning value for where statement
        $whereVar2 = ending value for where statement

    example:
        select_where_between(transmemhead,memNum,175,185)

*/

function select_where_between($table,$where,$whereVar1,$whereVar2)
{
    $query = "SELECT * FROM $table WHERE $where BETWEEN '$whereVar1' AND '$whereVar2'";
    $results = mysql_query($query) or
        die("<ol><li>errorno=" . mysql_errno() . "</li>"
            ."<li>error=" . mysql_error() . "</li>"
            ."<li>query=" . $query . "</li></ol>");
    $number_cols = mysql_num_fields($results);
    //display query
    echo "<b>query: $query</b>";
    //layout table header
    echo "<table border = '1'>\n";
    echo "<tr align = 'left'>\n";
    for($i=0; $i<$number_cols; $i++) {
        echo "<th>" . mysql_field_name($results,$i) . "</th>\n";
    }
    echo "</tr>\n"; //end table header
    //layout table body
    while($row = mysql_fetch_row($results)) {
        echo "<tr align = 'left'>\n";
        for ($i=0;$i<$number_cols; $i++) {
        echo "<td>";
            if(!isset($row[$i])) {
                //test for null value
                echo "NULL";
            }
            else {
                echo $row[$i];
            }
            echo "</td>\n";
        }
        echo "</tr>\n";
    }
    echo "</table>\n";
}
/* ----------------------------end select_where_between------------------*/


/* ----------------------------start select_to_drop----------------------*/
/* creates a dynamic drop down menu for use in forms. Variables are:
    $table = table for select
    $value = field to be used for drop down value
    $label = field to be used for the label on the drop down menu
    $name = name of the drop down menu
    
    example:
        select_to_drop(depts,deptNum,deptDesc,deptList)
        
*/

function select_to_drop($table,$value,$label,$name)
{
    $query = "SELECT * FROM $table";
    $results = mysql_query($query) or
        die("<ol><li>errorno=" . mysql_errno() . "</li>"
            . "<li>error=" . mysql_error() . "</li>"
            . "<li>query=" . $query . "</li></ol>");
    $number_cols = mysql_num_fields($results);
    //display query
    echo "<b>query: $query</b>";
    echo "<select name='$name' id='$name'>";
    do {
        echo "<option value='" . $row_members[$value] . "'>";
        echo $row_members[$label];
        echo "</option>";
    } while ($row_members = mysql_fetch_assoc($results));
    $rows = mysql_num_rows($results);
    if($rows > 0) {
        mysql_data_seek($results, 0);
        $row_members = mysql_fetch_assoc($results);
    }
}

